<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Tugas 12 Ajax-Axios</title>
</head>

<body>
    <div id="app">
        <form @submit.prevent="submitForm()">
            <p v-if="errors.length">
                <b>Please correct this following errors :</b>
            <ul>
                <li v-for="error in errors"> {{ error }} </li>
            </ul>
            </p>

            <label>Name :</label>
            <input type="text" name="name" ref="name" v-model="name"><br>
            <label>Address :</label>
            <textarea name="address" ref="address" v-model="address"></textarea><br>
            <label>No Hp :</label>
            <input type="number" name="no_hp" ref="no_hp" v-model="no_hp"><br>

            <div v-if="buttonStatus == 'submit' ">
                <input type="submit" value="SUBMIT">
            </div>
            <div v-else-if="buttonStatus == 'update' ">
                <input type="button" @click="updateMember(idEditMember)" value="UPDATE">
                <input type="button" value="CANCEL" @click="clearForm" style="margin-top: 5px">
            </div>
            <div v-else-if="buttonStatus == 'upload' ">
                <input type="file" name="photo_profile" ref="photo_profile">
                <input type="button" value="UPLOAD" @click="submitPhoto(idUploadMember)"
                    style="margin-top:5px; margin-bottom: 5px">
                <input type="button" value="CANCEL" @click="clearForm" style="margin-top: 5px">
            </div>
        </form>

        <br><br>

        <table border="1">
            <tr v-for="member of members">
                <td>
                    <img width="100"
                        :src="member.photo_profile  ? photoDomain + member.photo_profile : 'https://dummyimage.com/16:9x1080' "
                        alt="">
                </td>
                <td>
                    <b>Name : </b>{{ member.name }} <br>
                    <b>Address : </b>{{ member.address }} <br>
                    <b>No Hp : </b>{{ member.no_hp }} <br>
                </td>
                <td>
                    <button @click="editMember(member)">Edit</button>
                    <button @click="removeMember(member.id)">Hapus</button>
                    <button @click="uploadPhoto(member)">Upload Photo</button>
                </td>
            </tr>
        </table>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
        var vm = new Vue({
            el: '#app',
            data: {
                name: '',
                address: '',
                no_hp: '',
                errors: [],
                members: [],
                buttonStatus: 'submit',
                idEditMember: null,
                idUploadMember: null,
                photoDomain: 'http://demo-api-vue.sanbercloud.com'
            },
            methods: {
                validationForm: function () {
                    this.errors = []
                    if (this.name.length < 5) {
                        this.errors.push('Nama minimal 5 karakter')
                        this.$refs.name.focus()

                    }

                    if (this.address.length > 50) {
                        this.errors.push('Alamat tidak boleh lebih dari 50 karakter')
                        this.$refs.address.focus()

                    }

                    if (this.no_hp.length > 14) {
                        this.errors.push('Nomor HP tidak boleh lebih dari 14 angka')
                        this.$refs.no_hp.focus()
                    }
                },

                clearForm: function () {
                    this.name = ''
                    this.address = ''
                    this.no_hp = ''
                },

                submitForm: function () {
                    this.validationForm()

                    if (this.errors.length === 0) {
                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('address', this.address)
                        formData.append('no_hp', this.no_hp)

                        const config = {
                            method: "post",
                            url: "http://demo-api-vue.sanbercloud.com/api/member",
                            data: formData
                        }

                        axios(config)
                            .then((response) => {
                                this.clearForm()
                                this.getMembers()
                                alert(response.data.message)

                            })
                            .catch((error) => {
                                console.log(error);
                            })
                    }
                },

                getMembers: function () {
                    const config = {
                        method: "get",
                        url: "http://demo-api-vue.sanbercloud.com/api/member"
                    }
                    
                    axios(config)
                        .then((response) => {
                            this.members = response.data.members
                        })
                        .catch((error) => {
                            console.log(error);
                        })
                },

                removeMember: function (id) {

                    const config = {
                        method: "post",
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params: { _method: "DELETE" }
                    }

                    axios(config)
                        .then((response) => {
                            this.getMembers()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            console.log(error)
                        })
                },

                editMember: function (member) {
                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.buttonStatus = 'update'
                    this.idEditMember = member.id
                },

                clearForm: function () {
                    this.name = ''
                    this.address = ''
                    this.no_hp = ''
                    this.buttonStatus = 'submit'
                    this.idEditMember = null
                    this.idUploadMember = null
                },

                updateMember: function (id) {
                    this.validationForm()
                    if (this.errors.length === 0) {
                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('address', this.address)
                        formData.append('no_hp', this.no_hp)

                        let config = {
                            method: "post",
                            url: `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                            params: { _method: 'PUT' },
                            data: formData
                        }

                        axios(config)
                            .then((response) => {
                                this.clearForm()
                                this.getMembers()
                                alert(response.data.message)
                            })
                            .catch((error) => {
                                console.log(error);
                            })
                    }
                },

                uploadPhoto: function (member) {
                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.buttonStatus = 'upload'
                    this.idUploadMember = member.id
                },

                submitPhoto: function (id) {

                    let file = this.$refs.photo_profile.files[0]

                    let formData = new FormData()
                    formData.append('photo_profile', file)

                    let config = {
                        method: "post",
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                        data: formData
                    }

                    axios(config)
                        .then((response) => {
                            this.clearForm()
                            this.getMembers()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            console.log(error);
                        })
                }
            },
            created() {
                this.getMembers()
            }
        })
    </script>
</body>

</html>